<template>
	<div class="vairus-list lightestazure-color" :class="{'not-main' : !main}">
		<div class="filters flex v-center">
			<div class="title hustle medium">{{getLocale('vairus_list')}}</div>
		
			<div class="select">
				<select class="order small-col-padding" v-model="order">
					<option value="">{{getLocale('catch_date')}}</option>
					<option value="name">{{getLocale('name')}}</option>
					<option value="level">{{getLocale('level')}}</option>
					<option value="rarity">{{getLocale('rarity')}}</option>
					<option value="totalstat">{{getLocale('totalstat')}}</option>
					<option value="potential">{{getLocale('potential')}}</option>
					<option value="hazard">{{getLocale('hazard')}}</option>
					<option value="secrecy">{{getLocale('secrecy')}}</option>
					<option value="adaptability">{{getLocale('adaptability')}}</option>
					<option value="rapidity">{{getLocale('rapidity')}}</option>
				</select>
			</div>
			
			<div 
				class="order-direction medium-font small-col-padding noselect" 
				v-on:click="changeOrderDirection"
				v-bind:class="{ reverse: order_direction == -1 }"
			>
				&darr;
			</div>
			
			<div class="search-wrapper">
				<input class="search small-col-padding" v-bind:placeholder="getLocale('search')" v-model="search" @contextmenu="resetSearch" @keydown="page = 0">
				<tutorial-icon color="#B3EDFF" v-tooltip="'search_filters'"/>
			</div>
			
			<div v-if="main" class="codex-button" v-on:click="openCodex">
				Codex
			</div>
			
			<div v-if="main && checkTutorial('network')" class="destroy-toggle flex v-center" :class="[ select_mode ? 'cancel' : 'destroy']"  v-on:click="toggleSelectMode">
				<close-icon  v-if="select_mode" color="#B3EDFF" />
				
				<svg v-else xmlns="http://www.w3.org/2000/svg" width="13.25" height="15.288" viewBox="0 0 13.25 15.288">
					<g id="trash-fill" transform="translate(-1.875)">
						<path id="Tracciato_206" data-name="Tracciato 206" d="M2.894,1.019A1.019,1.019,0,0,0,1.875,2.038V3.058A1.019,1.019,0,0,0,2.894,4.077H3.4V13.25a2.038,2.038,0,0,0,2.038,2.038h6.115A2.038,2.038,0,0,0,13.6,13.25V4.077h.51a1.019,1.019,0,0,0,1.019-1.019V2.038a1.019,1.019,0,0,0-1.019-1.019H10.538A1.019,1.019,0,0,0,9.519,0H7.481A1.019,1.019,0,0,0,6.462,1.019ZM5.952,5.1a.51.51,0,0,1,.51.51V12.74a.51.51,0,0,1-1.019,0V5.606A.51.51,0,0,1,5.952,5.1ZM8.5,5.1a.51.51,0,0,1,.51.51V12.74a.51.51,0,0,1-1.019,0V5.606A.51.51,0,0,1,8.5,5.1Zm3.058.51a.51.51,0,1,0-1.019,0V12.74a.51.51,0,1,0,1.019,0Z" transform="translate(0)" fill="#b3edff" fill-rule="evenodd"/>
					</g>
				</svg>

				<div class="text">{{ getLocale('cancel') }}</div>
			</div>
			
		</div>
		
		<div class="list-container flex">
			<div class="vairus-boxes" :class="{editing : box_edit}">
				<div class="wrapper">
					<div v-for="(box, index) in boxes" :key="index" @mouseover="hovered_box = index" @mouseleave="hovered_box = null">
						<div class="vairus-box flex v-center" v-bind:class="{ active: (index == current_box) }" v-on:click="changeBox(index)">
							<span v-if="box_edit != index">{{box.name}}</span>
							
							<div class="flex v-center space columns-12" v-if="index != 0 && main">
								<form v-on:submit.prevent="toggleBoxEdit(index)">
									<input type="text" v-show="box_edit == index" v-model="box_label" spellcheck="false" :ref="'label'+index">
								</form>
								
							</div>
							
							<div class="edit-icon" v-on:click.stop="toggleBoxEdit(index)" v-if="index != 0 && main && !select_mode && !dragging">
								<div v-if="true" class="inner" v-bind:style="{backgroundImage : 'url('+getImage('edit.svg')+')'}"></div>
								<div v-else class="inner" v-bind:style="{backgroundImage : 'url('+getImage('tick.svg')+')'}"></div>
							</div>
							
							<div class="transfer-icon" 
								v-if="((select_mode && selected.length > 0) || dragging) && current_box != index"
								v-on:click.stop="transferVairus(index)"
							>
								<svg style="width:24px;height:24px" viewBox="0 0 24 24">
									<path fill="currentColor" d="M10.05 16.94V12.94H18.97L19 10.93H10.05V6.94L5.05 11.94Z" />
								</svg>
							</div>
						</div>
					</div>
				</div>
			</div>
			
			<Container 
				class="list" 
				behaviour="copy" 
				v-if="pagedVairus.length > 0" 
				@drag-end="onDragEnd" 
				@drag-start="onDragStart" 
				:get-child-payload="getDraggedVairus"
				:animation-duration="100"
			>
				<Draggable v-for="(vairus, index) in pagedVairus" :key="vairus.unique_id">
					<vairus-card 
						:vairus="vairus"
						:highlighted="highlighted(vairus)"
						:show_footer="show_footer"
						:stats="stats"
						@clicked=clicked
						@rightclicked=selectVairus
					/>
				</Draggable>
			</Container>
			
			<div class="no-vairus-message medium-font" v-else>{{ getLocale('no_vairus') }}</div>
		</div>
		
		<div class="pagination flex" v-if="searchedVairus.length > 50">
			<div class="number">
				{{page*50+1}}—{{Math.min(page*50+50, searchedVairus.length)}}
			</div>
			<div class="nav flex">
				<div class="prev" v-on:click="decreasePage"><div class="arrow"></div></div>
				<div class="next" v-on:click="increasePage"><div class="arrow"></div></div>
			</div>
		</div>
	
		<div class="destroy-info darkred-bkg  lightestred-color row-padding" v-if="main && select_mode && checkTutorial('network')">
			<div class="main-column">
				<div class="flex">
					<div class="title hustle medium">{{getLocale('delete')}}</div>
					<div class="flex space columns-12">
						<div class="description">{{getLocale('destroy_explanation')}}</div>
						
						<div>
							<div class="flex v-center">
								<close-icon @clicked="toggleSelectMode" color="#FFC7E5" />
								
								<v-button
									class="destroy-button darkestred-color" 
									color="lightestred"
									@clicked="destroyMass"
									:text="getLocale('destroy')"
									:secondary_text="deleteInfo.length+' Vairus'"
								/>
							</div>
							
							<div class="gains flex v-center space uppercase">
								<div class="text bold">{{getLocale('you_get')}}</div>
								<div class="flex v-center">
									{{deleteInfo.bytes}}
									<bytes-icon class="icon lightestred-color"/>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import Vue from 'vue';
	import VButton from '../components/VButton.vue';
	import TutorialIcon from '../components/TutorialIcon.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import BytesIcon from '../components/BytesIcon.vue';
	import VairusCard from '../components/VairusCard.vue';
	import { commonMixin } from '../mixins/common.js';
	import { Container, Draggable } from "vue-dndrop";
	
	export default {
		props: ['main', 'list', 'boxes', 'stats', 'show_footer', 'tutorial'],
		data: function () {
			return{
				last_selected : null,
				selected : [],
				select_mode : false,
				current_box : 0,
				edit_icon : 'url('+browser.runtime.getURL('/images/edit.svg')+')',
				box_label : '',
				box_edit : null,
				hovered_box : null,
				dragging : false,
				order : '',
				order_direction : 1,
				search : '',
				new_search : {
					search : '',
					params : {}
				},
				page : 0,
			}
		},
		methods: {
			clicked(unique_id, e){
				if(!this.select_mode){
					this.$emit('clicked', unique_id);
				}else{
					if(e.shiftKey){
						//Multiple selection
						let start = false;
						let end = false;
						
						if(this.last_selected == null)
							start = true;
						
						for(var i=0; i<this.pagedVairus.length; i++){
							var v_id = this.pagedVairus[i].unique_id;
							
							if(start && end) break;
							
							if(v_id == unique_id)
								end = true;
						
							if(v_id == this.last_selected)
								start = true;
								
							if((start || end) && this.selected.indexOf(v_id) === -1){
								this.selectVairus(v_id);
							}
						}
					}else{
						this.selectVairus(unique_id);
					}
					this.last_selected = unique_id;
				}
			},
			openCodex(){
				if(this.main){
					this.$emit('codex');
				}
			},
			highlighted(vairus){
				if(!vairus) return '';
				return (this.selected.indexOf(vairus.unique_id) !== -1 || (this.$store && vairus.unique_id == this.$store.state.detailed_vairus)) ? 'selected' : '';
			},
			toggleSelectMode(){
				if(this.select_mode){
					this.selected = [];
					this.last_selected = null;
				}
				this.select_mode = !this.select_mode;
			},
			selectVairus(unique_id, force_add = false){
				this.select_mode = true;
			
				let index = this.selected.indexOf(unique_id);
				
				if( index === -1){
					this.selected.push(unique_id);
				}else{
					if(!force_add){
						this.selected.splice(index, 1);
						if(this.selected.length == 0){
							this.select_mode = false;
						}
					}
				}
				
				this.$nextTick(function(){
					this.last_selected = unique_id;
				}.bind(this));
			},
			nextDetail(unique_id, type){
				let current_index = this.pagedVairus.findIndex(function(v){ return v.unique_id == unique_id; });
				let new_index = ((type == 'next') ? current_index+1 : current_index-1)%this.pagedVairus.length;
				
				if(new_index == -1) new_index = this.pagedVairus.length-1;
				
				return this.pagedVairus[new_index].unique_id;
			},
			destroyMass(){
				this.$emit('destroymass', this.selected);
				this.selected = [];
				this.select_mode = false;
			},
			changeBox(box){
				if(box != this.current_box){
					this.current_box = box;
					this.page = 0;
					this.box_edit = null;
				}
			},
			toggleBoxEdit(index){
				this.changeBox(index);
				
				if(this.box_edit != null){
					this.box_edit = null;
					this.$emit('editboxlabel', this.box_label, index);
					this.edit_icon = 'url('+browser.runtime.getURL('/images/edit.svg')+')';
				}else{
					this.box_edit = index;
					this.box_label = this.boxes[index].name;
					this.$nextTick(() => this.$refs['label'+index][0].focus())
					this.edit_icon = 'url('+browser.runtime.getURL('/images/tick.svg')+')';
				}
			},
			selectOrder(order){
				this.order = order;
			},
			changeOrderDirection(){
				this.order_direction = -1*this.order_direction;
			},
			decreasePage(){
				if(this.page > 0){
					this.page--;
				}
			},
			increasePage(){
				if(this.page < Math.floor(this.searchedVairus.length/50)){
					this.page++
				}
			},
			resetSearch(e){
				e.preventDefault();
				this.search = '';
			},
			onDragStart(e){
				this.dragging = true;
				if(this.hovered_box != null){
					this.$emit('addtobox', this.hovered_box, e.payload, this.current_box);
				}
				if(this.selected.length > 0){
					this.selectVairus(e.payload, true)
				}
			},
			onDragEnd(e){
				this.dragging = false;
				if(this.hovered_box != null){
					if(this.selected.length > 0){
						this.transferVairus(this.hovered_box);
					}else{
						this.$emit('addtobox', this.hovered_box, e.payload, this.current_box);
					}
				}
			},
			getDraggedVairus(index){
				return this.pagedVairus[index].unique_id;
			},
			transferVairus(index){
				this.$emit('transfertobox', this.selected, index);
				this.selected = [];
				this.select_mode = false;
			}
		},
		computed: {
			filteredVairus(){
				let filtered_vairus;
				let boxes = this.boxes;
				let current_box = this.current_box;
				
				//Filter the Vairus by current box
				if(this.current_box == 0){
					//The first box contain all the Vairus that are not in an other box
					filtered_vairus  = this.list;
					
					boxes = this.boxes.slice();
					boxes.shift();
					
					let other_boxes_vairus = boxes.reduce(function(vairus, box){
						return vairus.concat(box.vairus);
					}, []);
					
					filtered_vairus  = this.list.filter(function(v){
						return other_boxes_vairus.indexOf(v.unique_id) === -1;
					});
				}else{
					filtered_vairus = this.list.filter(function(v){
						return (boxes[current_box].vairus.indexOf(v.unique_id) !== -1);
					});
				}
				
				//Filter the exhausted Vairus if we're not in the main list
				if(!this.$props.main){
					let current_time = new Date().getTime();
					filtered_vairus = filtered_vairus.filter(function(v){
						if(v.exhaustion == null){
							return true;
						}else if(typeof v.exhaustion == 'string'){
							return false;
						}else{
							return (current_time > v.exhaustion);
						}
					});
				}
				
				return filtered_vairus;
			},
			searchedVairus(){
				return this.filteredVairus.filter(function(v){
					let check = v.label.toLowerCase().indexOf(this.new_search.search.toLowerCase()) !== -1;
					
					if(check == true){
						for(var param in this.new_search.params){
							let comparator_fn;
							let value;
							
							switch(param){
								case 'vairus':
								case 'v':
									value = this.new_search.params[param].value;
									check = (value == v.vairus_type.id) && check;
								break;
								case 'statistics':
								case 'statistic':
								case 's':
									comparator_fn = this.new_search.params[param].comparator;
									value = this.new_search.params[param].value;
									
									var total = 0;
									for(let stat in v.current_stats){
										total+= v.current_stats[stat].total;
									}
									check = comparator_fn(total,value) && check;
								break;
								case 'potential':
								case 'p':
									comparator_fn = this.new_search.params[param].comparator;
									value = this.new_search.params[param].value;
									
									var bonus_points_string = ('0000'+v.bonus_points).slice(-4);
									var total = 0;
									for(let i=0; i<4; i++){
										total+= parseInt(bonus_points_string[i])+1;
									}
									let percent = Math.floor((total*100)/40);
									
									check = comparator_fn(percent,value) && check;
								break;
								case 'mutations':
								case 'mutation':
								case 'm':
									value = this.new_search.params[param].value;
									check = (v.attributes.indexOf(value) != -1) && check;
								break;
								case 'level':
								case 'l':
									comparator_fn = this.new_search.params[param].comparator;
									value = this.new_search.params[param].value;
									check = comparator_fn(v.level,value) && check;
								break;
							}
						}
					}
					
					return check;
				}.bind(this));
			},
			orderedVairus(){
				let order_direction = this.order_direction;
				let ordered_vairus = this.searchedVairus;

				//Ordering
				switch(this.order){
					case 'name':
						ordered_vairus.sort(function(a,b){
							let order = (a.label.toLowerCase() > b.label.toLowerCase()) ? 1 : -1;
							return (order_direction === 1) ? order : -order;
						});
					break;
					case 'level':
						ordered_vairus.sort(function(a,b){
							let order = (a.level < b.level) ? 1 : -1;
							return (order_direction === 1)? order : -order;
						});
					break;
					case 'rarity':
						ordered_vairus.sort(function(a,b){
							let order = (a.vairus_type.id < b.vairus_type.id) ? 1 : -1;
							return (order_direction === 1)? order : -order;
						});
					break;
					case 'totalstat':
						ordered_vairus.sort(function(a,b){
							let a_sumstat = a.stats_array.reduce(function(total, value){ return total+value}, 0);
							let b_sumstat = b.stats_array.reduce(function(total, value){ return total+value}, 0);
							let order = (a_sumstat > b_sumstat) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					case 'potential':
						ordered_vairus.sort(function(a,b){
							let order = (a.potential > b.potential) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					case 'hazard':
						ordered_vairus.sort(function(a,b){
							let order = (a.current_stats.hazard.total > b.current_stats.hazard.total) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					case 'secrecy':
						ordered_vairus.sort(function(a,b){
							let order = (a.current_stats.secrecy.total > b.current_stats.secrecy.total) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					case 'adaptability':
						ordered_vairus.sort(function(a,b){
							let order = (a.current_stats.adaptability.total > b.current_stats.adaptability.total) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					case 'rapidity':
						ordered_vairus.sort(function(a,b){
							let order = (a.current_stats.rapidity.total > b.current_stats.rapidity.total) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
					break;
					default:
						ordered_vairus.sort(function(a,b){
							let order = (a.catch_time > b.catch_time) ? 1 : -1;
							return (order_direction !== 1)? order : -order;
						});
				}
				
				return ordered_vairus;
			},
			pagedVairus(){
				return this.orderedVairus.slice(this.page*50, this.page*50+50);
			},
			deleteInfo(){
				let list = this.list.filter(function(v){
					return this.selected.indexOf(v.unique_id) !== -1 && v.exhaustion != 'matrix' && v.exhaustion != 'assigned';
				}.bind(this));
				
				let bytes = list.reduce(function(bytes, v){
					let value = 0;
					switch(v.vairus_type.rarity){
						case 'common': value = 25; break;
						case 'uncommon': value = 50; break;
						case 'rare': value = 100; break;
						case 'epic': value = 250; break;
					}
					return bytes+value;
				}, 0);
				
				return {
					length : list.length,
					bytes : bytes
				}
			}
		},
		watch: {
			search: function (search) {
				let search_token = search.split('&');
				
				let search_data = {
					search : '',
					params : {}
				}
				
				for(let i=0; i<search_token.length; i++){
					let string = search_token[i];
					let comparator = '';
					let comparator_function = null;
					
					if(string.includes('=')){
						comparator = '=';
						comparator_function = comparator_eq;
					}else if(string.includes('<')){
						comparator = '<';
						comparator_function = comparator_mn;
					}else if(string.includes('>')){
						comparator = '>';
						comparator_function = comparator_mj;
					}else if(search_data.search == ''){
						search_data.search = string;
					}
					
					if(comparator != ''){
						let string_token = string.split(comparator);
						
						if(string_token.length > 1 && string_token[1] != ''){
							search_data.params[string_token[0]] = {
								comparator: comparator_function,
								value : string_token[1]
							}
						}
					}
				}
				
				this.new_search = search_data;
			}
		},
		mixins: [commonMixin],
		components: {
			VairusCard,
			TutorialIcon,
			CloseIcon,
			BytesIcon,
			VButton,
			Container, 
			Draggable
		}
	}
	
	function comparator_eq(a,b){
		return a == b;
	}
	function comparator_mj(a,b){
		return a > b;
	}
	function comparator_mn(a,b){
		return a < b;
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.vairus-list{
		.filters{
			margin-bottom: 20px;
			
			.title{
				width: 200px;
				flex-shrink: 0;
			}
			
			.order-direction{
				height: 33px;
				transition: all 0.2s;
				transform: scale(1, 1) translateY(5px);
				cursor: pointer;
				padding-left: 10px;
				padding-right: 10px;
				margin-right: 20px;
				
				&.reverse{
					transform: scale(-1, -1);
				}
			}
			.search-wrapper{
				position: relative;
				width: 100%;
				margin-right: 20px;
				
				.search{
					width: 100%;
					background-color: black;
				}
				
				.tutorial-icon{
					position: absolute;
					right: 10px;
					top: 10px;
				}
			}
			
			.codex-button{
				height: 40px;
				padding: 10px 20px;
				background-color: $darkestazure;
				border-radius: 10px;
				margin-right: 10px;
				cursor: pointer;
			}
			
			.destroy-toggle{
				height: 40.7px;
				padding: 10px;
				border-radius: 10px;
				transition: all 0.3s;
				cursor: pointer;
				
				.close-icon{
					height: 20px;
				}
				
				.text{
					max-width: 0;
					overflow: hidden;
					transition: all 0.3s;
				}
				
				&.cancel{
					background-color: $darkestazure;
					padding: 10px 20px;
					
					.text{
						max-width: 200px;
						margin-left: 50px;
					}
				}
			}
		}
		.list{
			flex: auto;
			display: grid;
			justify-content: center;
			grid-template-columns: repeat(auto-fit, minmax(244px, 244px));
			margin: 0 -10px;
			
			.vairus-card{
				transition: 0.2s;
				transform: scale(1);
				
				&:hover{
					transform: scale(1.05);
				}
			}
		}
		.no-vairus-message{
			margin-top: 10px;
		}
		.vairus-boxes{
			width: 200px;
			margin-top: 10px;
			padding-right: 20px;
			
			.wrapper{
				position: sticky;
				top: 20px;
				flex-wrap: wrap;
				
				.vairus-box{
					position: relative;
					height: 40px;
					padding: 10px 20px;
					background-color: $darkestazure;
					border-radius: 10px;
					margin-bottom: 10px;
					cursor: pointer;
					
					span{
						white-space: nowrap;
					}
					
					input{
					    width: 80%;
						text-align: left;
						background-color: transparent;
						border: none;
						border-bottom: 1px solid $darkestazure;
						color: $darkestazure;
						font-size: 1em;
						margin-top: 1px;
						padding: 0;
						border-radius: 0;
						min-width: 0;
					
						&:focus{
							outline: none;
						}
					}
					
					.edit-icon{
						display: none;
						cursor: pointer;
						margin-right: 0;
						position: absolute;
						right: 15px;
						
						.inner{
						   background-size: cover;
							width: 18px;
							height: 18px;
						}
					}
					.transfer-icon{
						cursor: pointer;
						margin-right: 0;
						position: absolute;
						right: 15px;
						margin-top: 5px;
					}
					
					&:hover{
						background-color: $lightestazure;
						color: $darkestazure;
						
						.edit-icon{
							display: inline-block;
						}
					}
					
					&.active{
						background-color: $lightestazure;
						color: $darkestazure;
						cursor: default;
					}
				}
			}
			
			&.editing .edit-icon{
				display: none !important;
			}
			
			&.editing .active .edit-icon{
				display: inline-block !important;
			}
		}
		
		.destroy-info{
			position: fixed;
			bottom: 0;
			left: 0;
			width: 100%;
			z-index: 10;
			
			.title{
				width: 200px;
				flex-shrink: 0;
			}
			.description{
				width: 400px;
			}
			
			.gains{
				padding: 10px;
				
				.text{
					margin-left: 40px;
				}
				
				.bytes-icon{
					margin-left: 5px;
				}
			}
			.close-icon{
				margin-right: 20px;
			}
		}
		
		.pagination{
			margin: 25px 0;
			justify-content: right;
			
			.nav{
				margin-left: 10px;
				margin-top: -1px;
				
				.prev, .next{
					position: relative;
					padding: 5px;
					cursor: pointer;
					
					.arrow{
						width: 10px;
						height: 10px;
						border-left: 1px solid white;
						border-bottom: 1px solid white;
					}
				}
				.prev .arrow{
					transform: rotate(45deg);
				}
				.next .arrow{
					transform: rotate(-135deg);
				}
			}
		}
	}

	@media screen and (max-width: 860px) {
		.vairus-list{
			.filters{
				position: relative;
				flex-wrap: wrap;
				margin-bottom: 62px;
				
				.title{
					width: auto;
					padding-right: 20px;
				}
				
				.search-wrapper{
					position: absolute;
					top: 50px;
				}
			}
			
			.list-container{
				display: block !important;
			}
			.vairus-boxes{
				width: 100%;
				padding-right: 0;
				
				.wrapper{
					display: flex;
					
					.vairus-box{
						margin-right: 10px;
						padding-left: 10px;
						padding-right: 10px;
						
						.edit-icon{
							display: none !important; 
						}
					}
				}
			}
		}
	}
	@media screen and (max-width: 520px) {
		.vairus-list {
			.filters .title{
				display: none;
			}
			.filters .order-direction{
				margin-right: 0 !important;
			}
			.codex-button{
				padding: 10px !important;
			}
			select{
				padding: 10px !important;
				min-width: 175px;
			}
			.destroy-toggle{
				padding: 10px 5px !important;
			}
			.list{
				grid-template-columns: repeat(auto-fit, minmax(195px, 195px));
			}
			.vairus-card{
				width: 175px;
				height: 250px;
				
				&.has-stats{
					width: 214px;
				}
				
				.vairus-stats .stat{
					padding: 5px 0;
					
					.image{
						width: 20px;
						height: 20px;
						
						img{
							left: 2px;
							top: 2px;
							right: 2px;
							bottom: 2px;
							width: 16px;
							height: 16px;
						}
					}
				}
			}
		}
	}
	@media screen and (max-width: 400px) {
		.vairus-list {
			.list{
				grid-template-columns: repeat(auto-fit, minmax(160px, 160px));
				
				> div{
					transform: scale(0.8);
					transform-origin: top left;
					margin-bottom: -50px;
				}
			}
		}
	}
	
	/* NOT MAIN */
	
	.vairus-list.not-main{
		.list{
			grid-template-columns: repeat(auto-fit, minmax(295px, 295px));
		}
	}
</style>

<style lang="scss">
	@media screen and (max-width: 650px) {
		.vairus-list.not-main {
			.list{
				grid-template-columns: repeat(auto-fit, minmax(235px, 235px)) !important
			}
			.vairus-card{
				width: 175px;
				height: 250px;
				
				&.has-stats{
					width: 214px;
				}
				
				.vairus-stats .stat{
					padding: 5px 0;
					
					.image{
						width: 20px;
						height: 20px;
						
						img{
							left: 2px;
							top: 2px;
							right: 2px;
							bottom: 2px;
							width: 16px;
							height: 16px;
						}
					}
				}
			}
		}
	}
	@media screen and (max-width: 520px) {
		.vairus-list.not-main {
			.list{
				grid-template-columns: repeat(auto-fit, minmax(190px, 190px)) !important;
				
				> div{
					transform: scale(0.8);
					transform-origin: top left;
					margin-bottom: -50px;
				}
			}
		}
	}
	@media screen and (max-width: 430px) {
		.vairus-list.not-main {
			.list{
				grid-template-columns: repeat(auto-fit, minmax(150px, 150px)) !important;
				
				> div{
					transform: scale(0.6);
					margin-bottom: -90px;
				}
			}
		}
	}
</style>